﻿version
6.50
-1
1
Hashtable:Hashtable
Sub designer
end sub
@EndOfDesignText@
'A properties file is a simple text file with a list of keys and values separated with '='.
'Each line should include one pair.
'Empty lines are ignored, and also lines starting with ' (apostrophe).
'Notes:
' Spaces are not trimmed.
' Keys are casesensitive.

'Example file:
'Width=100
'Height=200

Sub Globals
	counter = 0
	hashPrefix = "hash"
	Dim keys(0)
End Sub

Public Sub Load(file)
	If Not(FileExist(file)) Then
		Msgbox("Cannot find " & file,"",cMsgboxOK, cMsgboxHand)
		Return 0
	End If
	handle = CreateNew
	ParseFile(file, hashPrefix & handle)
	Return counter
End Sub
Public Sub GetProperty(handle, key)
	If Control(hashPrefix & handle).ContainsKey(key) Then
		Return Control(hashPrefix & handle).Item(key)
	End If
	Return ""
End Sub
Public Sub CreateNew
	counter = counter + 1
	AddObject(hashPrefix & counter,"Hashtable")
	Control(hashPrefix & counter,"Hashtable").New1
	Return counter
End Sub
Public Sub AddProp(handle, key, value)
	hash = hashPrefix & handle
	Control(hash,"Hashtable").Remove(key)
	Control(hash,"Hashtable").Add(key,value)
End Sub
Public Sub Save(handle, file)
	FileOpen(c,file,cWrite)
	hash = hashPrefix & handle
	keys() = Control(hash,"Hashtable").ToArrayKeys
	For i = 0 To ArrayLen(keys())-1
		value = Control(hash,"Hashtable").Item(keys(i))
		FileWrite(c,keys(i) & "=" & value)
	Next
	FileClose(c)
End Sub

Private Sub ParseFile(file,hash)
	FileOpen(c,file,cRead)
	line = FileRead(c)
	Do While line <> EOF
		If IsLetter(StrAt(line,0)) AND StrIndexOf(line,"=",0) > -1 Then
			i = StrIndexOf(line,"=",0)
			key = SubString(line,0,i)
			value = SubString(line,i+1,StrLength(line)-i-1)
			Control(hash,"Hashtable").Remove(key)
			Control(hash,"Hashtable").Add(key,value)
		End If
		line = FileRead(c)
	Loop
	FileClose(c)
End Sub